%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                               PSG Type    PSG Object                  Location in Problem Statement                                                           Class
%matrix_m3n5test8_returns_data        data        matrix_m3n5test8_returns    linear(matrix_m3n5test8_returns)                                                        double
%matrix_m3n5test8_returns_vars        vars        matrix_m3n5test8_returns    linear(matrix_m3n5test8_returns)                                                        cell
%matrix_mu_m3n5test8_m_probability    prob        matrix_mu_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%matrix_mu_m3n5test8_m_data           data        matrix_mu_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%matrix_mu_m3n5test8_m_vars           vars        matrix_mu_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    cell
%matrix_sd_m3n5test8_m_data           data        matrix_sd_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%matrix_sd_m3n5test8_m_vars           vars        matrix_sd_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    cell
%matrix_m3n5test8_budget_data         data        matrix_m3n5test8_budget     linear(matrix_m3n5test8_budget)                                                         double
%matrix_m3n5test8_budget_vars         vars        matrix_m3n5test8_budget     linear(matrix_m3n5test8_budget)                                                         cell
%point_xtype_data                     data        point_xtype                 Box: >= parameter_bound_1, types = point_xtype                                          double
%point_xtype_vars                     vars        point_xtype                 Box: >= parameter_bound_1, types = point_xtype                                          cell
%parameter_alpha_data                 data        parameter_alpha             +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%parameter_bound_data                 data        parameter_bound             Constraint: <= parameter_bound                                                          double
%parameter_bound_1_data               data        parameter_bound_1           Box: >= parameter_bound_1, types = point_xtype                                          double
%parameter_solver_data                data        parameter_solver            solver: parameter_solver                                                                char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_m3n5test8_returns_data,matrix_m3n5test8_returns_vars,matrix_mu_m3n5test8_m_probability,matrix_mu_m3n5test8_m_data,matrix_mu_m3n5test8_m_vars,matrix_sd_m3n5test8_m_data,matrix_sd_m3n5test8_m_vars,matrix_m3n5test8_budget_data,matrix_m3n5test8_budget_vars,point_xtype_data,point_xtype_vars,parameter_alpha_data,parameter_bound_data,parameter_bound_1_data,parameter_solver_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_m3n5test8_returns',matrix_m3n5test8_returns_data,matrix_m3n5test8_returns_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_mu_m3n5test8_m',matrix_mu_m3n5test8_m_data,matrix_mu_m3n5test8_m_vars,[],matrix_mu_m3n5test8_m_probability);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_sd_m3n5test8_m',matrix_sd_m3n5test8_m_data,matrix_sd_m3n5test8_m_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_m3n5test8_budget',matrix_m3n5test8_budget_data,matrix_m3n5test8_budget_vars,[],[]);
count = count+1;
iargstruc_arr(count) = point_pack('point_xtype',point_xtype_data,point_xtype_vars);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  linear(matrix_m3n5test8_returns)',...
'  +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)',...
'Constraint: <= parameter_bound',...
'  linear(matrix_m3n5test8_budget)',...
'Box: >= parameter_bound_1, types = point_xtype',...
'solver: parameter_solver',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_bound_1',num2str(parameter_bound_1_data));
problem_statement = strrep(problem_statement,'parameter_solver',parameter_solver_data);
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

