%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%minimize
%linear(matrix_m3n5test8_returns)
%+9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)
%Constraint: <= parameter_bound
%linear(matrix_m3n5test8_budget)
%Box: >= parameter_bound_1, types = point_xtype
%solver: parameter_solver
%
%Input variables:
%
%Inputs                               PSG Type    PSG Object                  Location in Problem Statement                                                           Class
%matrix_m3n5test8_returns_data        data        matrix_m3n5test8_returns    linear(matrix_m3n5test8_returns)                                                        double
%matrix_m3n5test8_returns_vars        vars        matrix_m3n5test8_returns    linear(matrix_m3n5test8_returns)                                                        cell
%matrix_mu_m3n5test8_m_probability    prob        matrix_mu_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%matrix_mu_m3n5test8_m_data           data        matrix_mu_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%matrix_mu_m3n5test8_m_vars           vars        matrix_mu_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    cell
%matrix_sd_m3n5test8_m_data           data        matrix_sd_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%matrix_sd_m3n5test8_m_vars           vars        matrix_sd_m3n5test8_m       +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    cell
%matrix_m3n5test8_budget_data         data        matrix_m3n5test8_budget     linear(matrix_m3n5test8_budget)                                                         double
%matrix_m3n5test8_budget_vars         vars        matrix_m3n5test8_budget     linear(matrix_m3n5test8_budget)                                                         cell
%point_xtype_data                     data        point_xtype                 Box: >= parameter_bound_1, types = point_xtype                                          double
%point_xtype_vars                     vars        point_xtype                 Box: >= parameter_bound_1, types = point_xtype                                          cell
%parameter_alpha_data                 data        parameter_alpha             +9.6627*avg_pm_pen_ni_g(parameter_alpha,matrix_mu_m3n5test8_m,matrix_sd_m3n5test8_m)    double
%parameter_bound_data                 data        parameter_bound             Constraint: <= parameter_bound                                                          double
%parameter_bound_1_data               data        parameter_bound_1           Box: >= parameter_bound_1, types = point_xtype                                          double
%parameter_solver_data                data        parameter_solver            solver: parameter_solver                                                                char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\ready\Optimal Allocation of Stock Levels and Stochastic Customer Demands to a Capacitated Resource\data_problem_m3n5_short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_m3n5test8_returns_data,matrix_m3n5test8_returns_vars,matrix_mu_m3n5test8_m_probability,matrix_mu_m3n5test8_m_data,matrix_mu_m3n5test8_m_vars,matrix_sd_m3n5test8_m_data,matrix_sd_m3n5test8_m_vars,matrix_m3n5test8_budget_data,matrix_m3n5test8_budget_vars,point_xtype_data,point_xtype_vars,parameter_alpha_data,parameter_bound_data,parameter_bound_1_data,parameter_solver_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
